# Class SynthScrollPaneUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ScrollPaneUI
javax.swing.plaf.basic.BasicScrollPaneUI
javax.swing.plaf.synth.SynthScrollPaneUI

All Implemented Interfaces:
  `PropertyChangeListener, EventListener, SynthConstants, SynthUI, ScrollPaneConstants`

public class SynthScrollPaneUI extends BasicScrollPaneUI implements PropertyChangeListener, SynthUI
Provides the Synth L&F UI delegate for `JScrollPane`.

Since:
  1.7

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class BasicScrollPaneUI

  `BasicScrollPaneUI.HSBChangeListener, BasicScrollPaneUI.MouseWheelHandler, BasicScrollPaneUI.PropertyChangeHandler, BasicScrollPaneUI.ViewportChangeHandler, BasicScrollPaneUI.VSBChangeListener`
  Modifier and Type
  Class
  Description
  `class`
  `BasicScrollPaneUI.HSBChangeListener`
  Deprecated, for removal: This API element is subject to removal in a future version.
  `protected class`
  `BasicScrollPaneUI.MouseWheelHandler`
  MouseWheelHandler is an inner class which implements the MouseWheelListener interface.
  `class`
  `BasicScrollPaneUI.PropertyChangeHandler`
  Deprecated, for removal: This API element is subject to removal in a future version.
  `class`
  `BasicScrollPaneUI.ViewportChangeHandler`
  Deprecated, for removal: This API element is subject to removal in a future version.
  `class`
  `BasicScrollPaneUI.VSBChangeListener`
  Deprecated, for removal: This API element is subject to removal in a future version.

- ## Field Summary

  ### Fields declared in class BasicScrollPaneUI

  `hsbChangeListener, scrollpane, spPropertyChangeListener, viewportChangeListener, vsbChangeListener`
  Modifier and Type
  Field
  Description
  `protected ChangeListener`
  `hsbChangeListener`
  `ChangeListener` installed on the horizontal scrollbar.
  `protected JScrollPane`
  `scrollpane`
  The instance of `JScrollPane`.
  `protected PropertyChangeListener`
  `spPropertyChangeListener`
  `PropertyChangeListener` installed on the scroll pane.
  `protected ChangeListener`
  `viewportChangeListener`
  `ChangeListener` installed on the viewport.
  `protected ChangeListener`
  `vsbChangeListener`
  `ChangeListener` installed on the vertical scrollbar.

  ### Fields declared in interface ScrollPaneConstants

  `COLUMN_HEADER, HORIZONTAL_SCROLLBAR, HORIZONTAL_SCROLLBAR_ALWAYS, HORIZONTAL_SCROLLBAR_AS_NEEDED, HORIZONTAL_SCROLLBAR_NEVER, HORIZONTAL_SCROLLBAR_POLICY, LOWER_LEADING_CORNER, LOWER_LEFT_CORNER, LOWER_RIGHT_CORNER, LOWER_TRAILING_CORNER, ROW_HEADER, UPPER_LEADING_CORNER, UPPER_LEFT_CORNER, UPPER_RIGHT_CORNER, UPPER_TRAILING_CORNER, VERTICAL_SCROLLBAR, VERTICAL_SCROLLBAR_ALWAYS, VERTICAL_SCROLLBAR_AS_NEEDED, VERTICAL_SCROLLBAR_NEVER, VERTICAL_SCROLLBAR_POLICY, VIEWPORT`
  Modifier and Type
  Field
  Description
  `static final String`
  `COLUMN_HEADER`
  Identifies the area at the top the viewport between the upper left corner and the upper right corner.
  `static final String`
  `HORIZONTAL_SCROLLBAR`
  Identifies a horizontal scrollbar.
  `static final int`
  `HORIZONTAL_SCROLLBAR_ALWAYS`
  Used to set the horizontal scroll bar policy so that horizontal scrollbars are always displayed.
  `static final int`
  `HORIZONTAL_SCROLLBAR_AS_NEEDED`
  Used to set the horizontal scroll bar policy so that horizontal scrollbars are displayed only when needed.
  `static final int`
  `HORIZONTAL_SCROLLBAR_NEVER`
  Used to set the horizontal scroll bar policy so that horizontal scrollbars are never displayed.
  `static final String`
  `HORIZONTAL_SCROLLBAR_POLICY`
  Identifies the horizontal scroll bar policy property.
  `static final String`
  `LOWER_LEADING_CORNER`
  Identifies the lower leading edge corner of the viewport.
  `static final String`
  `LOWER_LEFT_CORNER`
  Identifies the lower left corner of the viewport.
  `static final String`
  `LOWER_RIGHT_CORNER`
  Identifies the lower right corner of the viewport.
  `static final String`
  `LOWER_TRAILING_CORNER`
  Identifies the lower trailing edge corner of the viewport.
  `static final String`
  `ROW_HEADER`
  Identifies the area along the left side of the viewport between the upper left corner and the lower left corner.
  `static final String`
  `UPPER_LEADING_CORNER`
  Identifies the upper leading edge corner of the viewport.
  `static final String`
  `UPPER_LEFT_CORNER`
  Identifies the upper left corner of the viewport.
  `static final String`
  `UPPER_RIGHT_CORNER`
  Identifies the upper right corner of the viewport.
  `static final String`
  `UPPER_TRAILING_CORNER`
  Identifies the upper trailing edge corner of the viewport.
  `static final String`
  `VERTICAL_SCROLLBAR`
  Identifies a vertical scrollbar.
  `static final int`
  `VERTICAL_SCROLLBAR_ALWAYS`
  Used to set the vertical scroll bar policy so that vertical scrollbars are always displayed.
  `static final int`
  `VERTICAL_SCROLLBAR_AS_NEEDED`
  Used to set the vertical scroll bar policy so that vertical scrollbars are displayed only when needed.
  `static final int`
  `VERTICAL_SCROLLBAR_NEVER`
  Used to set the vertical scroll bar policy so that vertical scrollbars are never displayed.
  `static final String`
  `VERTICAL_SCROLLBAR_POLICY`
  Identifies the vertical scroll bar policy property.
  `static final String`
  `VIEWPORT`
  Identifies a "viewport" or display area, within which scrolled contents are visible.

  ### Fields declared in interface SynthConstants

  `DEFAULT, DISABLED, ENABLED, FOCUSED, MOUSE_OVER, PRESSED, SELECTED`
  Modifier and Type
  Field
  Description
  `static final int`
  `DEFAULT`
  Indicates the region is the default.
  `static final int`
  `DISABLED`
  Primary state indicating the region is not enabled.
  `static final int`
  `ENABLED`
  Primary state indicating the component is enabled.
  `static final int`
  `FOCUSED`
  Indicates the region has focus.
  `static final int`
  `MOUSE_OVER`
  Primary state indicating the mouse is over the region.
  `static final int`
  `PRESSED`
  Primary state indicating the region is in a pressed state.
  `static final int`
  `SELECTED`
  Indicates the region is selected.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SynthScrollPaneUI()`
  Constructs a `SynthScrollPaneUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ComponentUI`
  `createUI(JComponent x)`
  Creates a new UI object for the given component.
  `SynthContext`
  `getContext(JComponent c)`
  Returns the Context for the specified component.
  `void`
  `paint(Graphics g, JComponent c)`
  Paints the specified component according to the Look and Feel.
  `protected void`
  `paint(SynthContext context, Graphics g)`
  Paints the specified component.
  `void`
  `paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)`
  Paints the border.
  `void`
  `propertyChange(PropertyChangeEvent e)`
  This method gets called when a bound property is changed.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate to repaint the specified component.

  ### Methods declared in class BasicScrollPaneUI

  `createHSBChangeListener, createMouseWheelListener, createPropertyChangeListener, createViewportChangeListener, createVSBChangeListener, getBaseline, getBaselineResizeBehavior, getMaximumSize, installDefaults, installKeyboardActions, installListeners, syncScrollPaneWithViewport, uninstallDefaults, uninstallKeyboardActions, uninstallListeners, updateColumnHeader, updateRowHeader, updateScrollBarDisplayPolicy, updateViewport`
  Modifier and Type
  Method
  Description
  `protected ChangeListener`
  `createHSBChangeListener()`
  Returns an instance of horizontal scroll bar `ChangeListener`.
  `protected MouseWheelListener`
  `createMouseWheelListener()`
  Creates an instance of MouseWheelListener, which is added to the JScrollPane by installUI().
  `protected PropertyChangeListener`
  `createPropertyChangeListener()`
  Creates an instance of `PropertyChangeListener` that's added to the `JScrollPane` by `installUI()`.
  `protected ChangeListener`
  `createViewportChangeListener()`
  Returns an instance of viewport `ChangeListener`.
  `protected ChangeListener`
  `createVSBChangeListener()`
  Returns an instance of vertical scroll bar `ChangeListener`.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `protected void`
  `installDefaults(JScrollPane scrollpane)`
  Installs default properties.
  `protected void`
  `installKeyboardActions(JScrollPane c)`
  Registers keyboard actions.
  `protected void`
  `installListeners(JScrollPane c)`
  Registers listeners.
  `protected void`
  `syncScrollPaneWithViewport()`
  Synchronizes the `JScrollPane` with `Viewport`.
  `protected void`
  `uninstallDefaults(JScrollPane c)`
  Uninstalls default properties.
  `protected void`
  `uninstallKeyboardActions(JScrollPane c)`
  Unregisters keyboard actions.
  `protected void`
  `uninstallListeners(JComponent c)`
  Unregisters listeners.
  `protected void`
  `updateColumnHeader(PropertyChangeEvent e)`
  Updates column header.
  `protected void`
  `updateRowHeader(PropertyChangeEvent e)`
  Updates row header.
  `protected void`
  `updateScrollBarDisplayPolicy(PropertyChangeEvent e)`
  Updates a scroll bar display policy.
  `protected void`
  `updateViewport(PropertyChangeEvent e)`
  Updates viewport.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getMinimumSize, getPreferredSize, installUI, uninstallUI`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `Dimension`
  `getMinimumSize(JComponent c)`
  Returns the specified component's minimum size appropriate for the look and feel.
  `Dimension`
  `getPreferredSize(JComponent c)`
  Returns the specified component's preferred size appropriate for the look and feel.
  `void`
  `installUI(JComponent c)`
  Configures the specified component appropriately for the look and feel.
  `void`
  `uninstallUI(JComponent c)`
  Reverses configuration which was done on the specified component during `installUI`.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SynthScrollPaneUI

    public SynthScrollPaneUI()
    Constructs a `SynthScrollPaneUI`.

- ## Method Details

  - ### createUI

    public static ComponentUI createUI(JComponent x)
    Creates a new UI object for the given component.
    Parameters:
      `x` - component to create UI object for
    Returns:
      the UI object

  - ### update

    public void update(Graphics g, JComponent c)
    Notifies this UI delegate to repaint the specified component. This method paints the component background, then calls the `paint(SynthContext,Graphics)` method.

    In general, this method does not need to be overridden by subclasses. All Look and Feel rendering code should reside in the `paint` method.

    Overrides:
      `update` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    public void paint(Graphics g, JComponent c)
    Paints the specified component according to the Look and Feel.

    This method is not used by Synth Look and Feel. Painting is handled by the `paint(SynthContext,Graphics)` method.

    Overrides:
      `paint` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    protected void paint(SynthContext context, Graphics g)
    Paints the specified component.
    Parameters:
      `context` - context for the component being painted
      `g` - the `Graphics` object used for painting
    See Also:
      - `update(Graphics,JComponent)`

  - ### paintBorder

    public void paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)
    Paints the border.
    Specified by:
      `paintBorder` in interface `SynthUI`
    Parameters:
      `context` - a component context
      `g` - `Graphics` to paint on
      `x` - the X coordinate
      `y` - the Y coordinate
      `w` - width of the border
      `h` - height of the border

  - ### getContext

    public SynthContext getContext(JComponent c)
    Returns the Context for the specified component.
    Specified by:
      `getContext` in interface `SynthUI`
    Parameters:
      `c` - Component requesting SynthContext.
    Returns:
      SynthContext describing component.

  - ### propertyChange

    public void propertyChange(PropertyChangeEvent e)
    Description copied from interface: `PropertyChangeListener`
    This method gets called when a bound property is changed.
    Specified by:
      `propertyChange` in interface `PropertyChangeListener`
    Parameters:
      `e` - A PropertyChangeEvent object describing the event source and the property that has changed.